Subject: Re: bug#63850: cp fails for files > 2 GB if copy offload is unsupported

From: Arsen Arsenović <[email-masked]>
Date: Sat, 03 Jun 2023 19:12:41 +0200

Mike Gilbert <[email-masked]> writes:

> The macro in copy-file-range.m4 performs a build time version check
> against the installed linux headers (/usr/include/linux).
>
> In this case, headers from linux-6.1 are being used at build time.
> However, the code is being run on a linux-4.19 kernel.
>
> Generally speaking, syscall checks must be done at run time on Linux,
> not build time.

Right, the replacement should always be emitted (perhaps with glibc stub
detection, and omitted if one is found, though).  linux-headers is a
weird library, in that it makes no implication about the compatibility
level of your resulting executable, so, no assumption about runtime
versions or behavior can be made from static checks.
-- 
Arsen Arsenović